#include <Audio.h>
#include <Wire.h>
#include <SPI.h>
#include <SD.h>
#include <SerialFlash.h>

// GUItool: begin automatically generated code
AudioSynthWaveformSine   sine3;          //xy=179,262
AudioSynthWaveformSine   sine1;          //xy=192,181
AudioSynthWaveformSine   sine2;          //xy=196,223
AudioMixer4              mixer1;         //xy=357,215
AudioEffectEnvelope      envelope1;      //xy=528,195
AudioEffectDelay         delay1;         //xy=668,368
AudioMixer4              mixer2;         //xy=671,235
AudioOutputAnalog        dac1;           //xy=847,231
AudioAnalyzePeak         peak1;          //xy=871,144
AudioConnection          patchCord1(sine3, 0, mixer1, 2);
AudioConnection          patchCord2(sine1, 0, mixer1, 0);
AudioConnection          patchCord3(sine2, 0, mixer1, 1);
AudioConnection          patchCord4(mixer1, envelope1);
AudioConnection          patchCord5(envelope1, 0, mixer2, 0);
AudioConnection          patchCord6(delay1, 0, mixer2, 1);
AudioConnection          patchCord7(mixer2, delay1);
AudioConnection          patchCord8(mixer2, dac1);
AudioConnection          patchCord9(mixer2, peak1);
// GUItool: end automatically generated code




#include <FastLED.h>

#define LED_PIN  A9 //a define is just a substitution. where you see LED_PIN it inserts A9. Unlike an varible it can't be changed
#define MAX_BRIGHTNESS 25
#define NUM_LEDS 64

CRGB led_grid[NUM_LEDS];

#define down_pin 8

unsigned long current_millis;
unsigned long  previous_millis1;
int interval1 = 250;
int high_freq;
unsigned long  previous_millis2;
int interval2 = 25;
float audio_reading;
int button_state,prev_button_state;

float freq[3];

int pot_value;       // were we will store the reading from the knob


void setup() {

  //required to setup audio. if it's too low it won't run.
  AudioMemory(100); //255 is max

  pinMode(down_pin, INPUT_PULLUP);

  sine1.amplitude(1);
  sine2.amplitude(1);
  sine3.amplitude(1);

  mixer1.gain(0, .33);
  mixer1.gain(1, .33);
  mixer1.gain(2, .33);

  mixer2.gain(0, .6); //direct audio level
  mixer2.gain(1, .6); // feedback leve

  delay1.delay(0, 150);

  FastLED.addLeds<WS2812B, LED_PIN, GRB>(led_grid, NUM_LEDS).setCorrection(TypicalSMD5050);
  FastLED.setBrightness( MAX_BRIGHTNESS );


}


void loop()
{

  current_millis = millis();

  pot_value = analogRead(A1) * 2;
  prev_button_state=button_state;
  button_state = digitalRead(down_pin);

  if (button_state == 0 && prev_button_state==1) {
  envelope1.noteOn();
  }

  if (button_state == 1 && prev_button_state==0) {
  envelope1.noteOff();
  }

  freq[0] = pot_value;
  freq[1] = pot_value * 2; // rate 2 is twice rate1 which would now mean double the pitch aka an octave
  freq[2] = pot_value * .95; //very close to original pitch;

  sine1.frequency(freq[0]);
  sine2.frequency(freq[1]);
  sine3.frequency(freq[2]);


  if (current_millis - previous_millis1 > interval1) {
    previous_millis1 = current_millis;
    
    Serial.println(freq[0]);

    Serial.println(audio_reading);

    Serial.print(AudioProcessorUsageMax());
    Serial.print(" ");
    Serial.println(AudioMemoryUsageMax());

    Serial.println();

    AudioProcessorUsageMaxReset();
    AudioMemoryUsageMaxReset();
  }


  if (current_millis - previous_millis2 > interval2) {
    previous_millis2 = current_millis;

    if (peak1.available()) {
    audio_reading=peak1.read()*(255.00-50.00);
    }
    
    high_freq=freq[0]/5;

    for (int i; i < NUM_LEDS; i++) {
      led_grid[i]  = CHSV( random(high_freq)+100, 255, audio_reading+50);
    }

    FastLED.setBrightness(MAX_BRIGHTNESS);  // change the brightness of everything
    FastLED.show();  // send the array data to the leds

  }


}



